<template src="./template.html"></template>

<script>
	export default {
		props: {
			working: {
				type: Boolean,
				default: false
			},
		},
		data() {
			return {
				telNumber: '',
				callingNumber: '',
				callStatus: false,
				callActive: false,
				calling: false,
				isHold: false,
				isConnected: false,

				sipStack: false,
				callSession: false,

				timerId: 0,
				timerCounter: 0,
				timerCounterDisplay: '00 : 00',

				callOnlineId: 0,
				handbookNumberSelected: null,
				handbookNumberList: [],
				orgList: [],
				crmCallClicked: false,
				phoneCode: 0,
			}
		},
		methods: {
			Dialer() {
				let _this = this;

				// let timeoutId = 0;
				// let plusClicked = false;
				//
				// $(document).on('mousedown', '.hd_contact_dial_num .num[data-number="0"]', function (e) {
				//
				// 	timeoutId = setTimeout(function () {
				// 		_this.telNumber += '+';
				// 		plusClicked = true;
				// 		document.getElementById('dtmfTone').play();
				// 	}, 500);
				//
				// }).on('mouseup mouseleave', '.hd_contact_dial_num .num[data-number="0"]', function() {
				// 	clearTimeout(timeoutId);
				// });


				$(document).on('click', '.hd_contact_dial_num .num', function () {
					// if (plusClicked) {
					// 	plusClicked = false;
					// }
					// else {
					_this.telNumber += String($(this).data('number'));
					document.getElementById('dtmfTone').play();
					// }
				});


				// $(document).on('click', '.hd_contact_col', function (e) {
				// 	$('#dialField').focus();
				// });

				$(document).on('click', '.hd_contact_dial_to_del', (e) => {
					if (this.telNumber !== '') {
						this.telNumber = this.telNumber.slice(0, this.telNumber.length - 1);
					}
				});
			},

			// HandbookSelect(val) {
			// 	this.telNumber = val.phoneNumber.toString();
			// },

			HandbookSelect(val) {
				console.log(val.code);
				this.phoneCode = val.code.toString();
			},


			CallInstance() {
				let identity = this.$store.state.operator_id;
				let hostname = location.hostname === 'localhost' ? 'crm24.uz' : location.hostname;

				this.sipStack = new SIPml.Stack({
						realm: hostname + ':5060',
						impi: identity,
						impu: 'sip:' + identity + '@' + hostname + ':5060',
						password: '#^aDg2WVw1',
						display_name: identity,
						websocket_proxy_url: 'wss://' + hostname + ':7443',
						ice_servers: [], //Khazratbek
						// enable_rtcweb_breaker: true, // optional
						// enable_click2call: false, // optional
						// enable_early_ims: true, // optional
						events_listener: {
							events: '*',
							listener: this.CallEventListener
						},
						sip_headers: [
							{name: 'User-Agent', value: 'IM-client/OMA1.0 sipML5-v1.0.0.0'},
							{name: 'Organization', value: 'Doubango Telecom'}
						]
					}
				);
				this.sipStack.start();
			},
			CallInit() {
				SIPml.init(this.CallInstance(), function (e) {
					console.error('Failed to initialize the engine: ' + e.message);
				});
			},
			CallLogin() {
				let registerSession = this.sipStack.newSession('register', {
					events_listener: {
						events: '*',
						listener: (e) => {
							// console.warn(e.type);
							if (e.type === 'connected') {
								this.callStatus = true;
							}
							// this.callStatus = e.type === 'connected';
						}
					} // optional: '*' means all events
				});

				registerSession.register();
			},
			CallStart() {
				if (this.telNumber !== '') {

					// this.$store.state.caller_id = this.telNumber[0] === '0' ? this.telNumber : this.telNumber.length > 4 ? '0' + this.telNumber : this.telNumber;
					this.$store.state.caller_id = this.phoneCode + this.telNumber;
					localStorage.setItem('caller_id', this.$store.state.caller_id);

					this.callActive = true;
					this.$store.state.isCalling = true;
					this.$router.push('/crm');

					// document.getElementById('ringbacktone').play();

					this.callSession = this.sipStack.newSession('call-audio', {
						audio_remote: document.getElementById('audio_remote'),
						events_listener: {
							events: '*',
							listener: this.CallEventListener,
						}
					});
					this.callSession.call(this.$store.state.caller_id);
				} else {
					setTimeout(() => {
						jabra.onHook();
					}, 100);
				}
			},
			CallEnd() {
				if (this.callSession) {
					let result = this.callSession.hangup({
						events_listener: {
							events: '*',
							listener: this.CallEventListener
						}
					});

					if (result < 0) {
						// this.sipStack.stop(0);
						// this.$emit('phoneStuck');


						this.callSession = false;
						this.callActive = false;
						this.isConnected = false;
						this.calling = false;
						this.callingNumber = '';

						this.isHold = false;

						document.getElementById('ringtone').pause();

						clearInterval(this.timerId);
						this.timerCounter = 0;
						this.timerCounterDisplay = '00 : 00';

						this.$store.state.call_terminated = true;

						this.$store.state.isCalling = false;

						jabra.onHook();


						// setTimeout(() => {
						// 	this.sipStack.start();
						// }, 5000);
					}
				}
			},
			CallAccept() {
				if (this.callSession) {
					this.callSession.accept({
						events_listener: {
							events: '*',
							listener: this.CallEventListener
						}
					});

					this.callActive = true;
				}
			},
			CallReject() {
				if (this.callSession) {
					this.callSession.reject({
						events_listener: {
							events: '*',
							listener: this.CallEventListener
						}
					});
				}
			},
			CallHoldResume() {
				// if (this.callSession && this.isConnected) {
				// 	if (this.isHold) {
				// 		this.callSession.resume({
				// 			events_listener: {
				// 				events: '*',
				// 				listener: this.CallEventListener
				// 			}
				// 		});
				// 	}
				// 	else {
				// 		this.callSession.hold({
				// 			events_listener: {
				// 				events: '*',
				// 				listener: this.CallEventListener
				// 			}
				// 		});
				// 	}
				// }
				if (this.callSession && this.isConnected) {
					if (!this.isHold) {
						this.isHold = true;
						this.callSession.mute("audio", true);
					} else {
						this.isHold = false;
						this.callSession.mute("audio", false);
					}
				}
			},
			CallTransfer() {
				if (this.isConnected) {
					let dest_num = prompt('Enter destination number', '');
					if (dest_num === '' || dest_num.trim() === '' || isNaN(dest_num)) {
						alert('The number that you entered is wrong!');
					} else {
						this.callSession.transfer(dest_num.length > 4 ? 0 + dest_num.trim() : dest_num.trim());
						this.CallEnd();
					}
				}
			},
			CallEventListener(e) {

				console.log({'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa': e.type});

				switch (e.type) {
					case 'started':
						this.CallLogin();
						break;


					case 'stopped':
						if (this.working) {
							this.sipStack.start();
						}
						break;


					case 'i_new_call':
						if (this.callSession) {
							// do not accept the incoming call if we're already 'in call'
							e.newSession.hangup();
						} else {
							document.getElementById('ringtone').play();
							$('.hd_contact_dial_bx').addClass('active');

							this.callSession = e.newSession;
							this.callSession.setConfiguration({
								audio_remote: document.getElementById('audio_remote'),
							});

							this.callingNumber = (this.callSession.getRemoteFriendlyName() || 'unknown');
							this.$store.state.caller_id = this.callingNumber;
							localStorage.setItem('caller_id', this.callingNumber);

							this.$store.state.isCalling = true;

							this.calling = true;

							this.CallOnline();

							if (this.callingNumber !== '0000000000') this.$router.push('/crm');

							jabra.ring();
						}
						break;


					case 'connecting':
						this.CallOnline();

						jabra.offHook();
						break;


					case 'connected':
						this.isConnected = true;
						this.calling = false;
						this.CallTimer();
						document.getElementById('ringtone').pause();

						jabra.offHook();
						// document.getElementById('ringbacktone').pause();
						break;


					case 'terminating':
					case 'terminated':
						this.callSession = false;
						this.callActive = false;
						this.isConnected = false;
						this.calling = false;
						this.callingNumber = '';

						this.isHold = false;

						document.getElementById('ringtone').pause();

						clearInterval(this.timerId);
						this.timerCounter = 0;
						this.timerCounterDisplay = '00 : 00';

						this.$store.state.call_terminated = true;
						this.$store.state.isCalling = false;

						jabra.onHook();
						break;


					case 'm_local_resume_ok':
						this.isHold = false;
						jabra.resume();
						break;


					case 'm_local_hold_ok':
						this.isHold = true;
						jabra.hold();
						break;
				}
			},
			CallTimer() {
				this.timerId = setInterval(() => {
					this.timerCounter += 1;

					if (this.timerCounter / 60 >= 1) {
						let minute = Math.floor(this.timerCounter / 60);
						this.timerCounterDisplay = '' + ((minute / 10 >= 1) ? minute : ('0' + minute));

						let second = this.timerCounter % 60;
						this.timerCounterDisplay += ' : ' + ((second / 10 >= 1) ? second : ('0' + second));
					} else {
						this.timerCounterDisplay = '00 : ' + ((this.timerCounter / 10 >= 1) ? this.timerCounter : ('0' + this.timerCounter));
					}
				}, 1000);
			},


			CallOnline() {
				this.callOnlineId = setInterval(() => {
					axios.get('/IvrFs/RunFsCommand?command=fs_cli -x "show channels like ' + this.$store.state.operator_id + '"')
						.then(response => {

							console.log(response.data);

							if (response.data.result.length === 0) {
								console.log('bbbbbbbbbbbbbbbbbbbbbbbbbbbbb');

								this.CallEnd();
								clearInterval(this.callOnlineId);
							}
						})
						.catch(error => {
							console.log(error.message);
						});
				}, 300000);
			},

			HandleOperatorKeyboard(e) {
				// console.log(e);

				if (e.ctrlKey && e.altKey && e.keyCode === 131) {
					if (this.calling) {
						this.CallAccept();
						console.warn('Accept');
					} else {
						if (!this.callActive) {
							this.CallStart();
							console.warn('Start');
						}
					}
				}
				if (e.ctrlKey && e.altKey && e.keyCode === 132) {
					if (this.calling) {
						this.CallReject();
						console.warn('Reject');
					} else {
						if (this.callActive) {
							this.CallEnd();
							console.warn('End');
						}
					}
				}
			},
			crmCall(number) {
				this.crmCallClicked = true;
				$(document).ready(function () {
					$('.hd_contact_tel').click();
				});
				this.telNumber = number;
				this.CallStart();
			},
			findCode() {
				if (parseInt(localStorage.getItem('organization_id')) != 0) {
					let code = this.orgList.find(x => x.id == parseInt(localStorage.getItem('organization_id')));
					return code.code;
				} else {
					return 0;
				}
			}
		},
		async mounted() {
			this.Dialer();


			jabra.init().then(() => {
				// console.warn('Jabra Success');

				jabra.addEventListener("acceptcall", e => {
					// console.log('Jabra acceptcall', e);

					if (this.calling) {
						this.CallAccept();
						console.warn('Jabra Accept');
					} else {
						if (!this.callActive) {
							this.CallStart();
							console.warn('Jabra Start');
						}
					}
				});

				jabra.addEventListener("endcall", e => {
					// console.log('Jabra endcall', e);

					if (!this.calling && this.callActive) {
						this.CallEnd();
						console.warn('Jabra End');
					}
				});


				jabra.addEventListener("flash", e => {
					console.warn('Jabra flash', e);

					this.CallHoldResume();
				});

			}).catch((err) => {
				console.warn('Jabra Error');
			});


			document.addEventListener('keydown', this.HandleOperatorKeyboard);


			setTimeout(() => {
				this.CallInit();
			}, 2000);


			await axios
				.get('/Admin/organization')
				.then(response => {
					this.orgList = response.data.data;
				})
				.catch(error => console.warn(error.message));

			axios
				.get('/ShortNumber/getShortNumbers')
				.then(response => {
					this.handbookNumberList = response.data.shortNumbers;
				})
				.catch(error => console.warn(error.message));

		},
		destroyed() {
			document.removeEventListener('keydown', this.HandleOperatorKeyboard);
		},
		watch: {
			'telNumber'(val) {
				this.telNumber = val.replace(/[^0-9]/g, '');
			},
			'working'(val) {
				console.log('Authorized', val);


				if (!val) {
					this.sipStack.stop();
				}
			},
			'$store.state.crmPhone'(val) {
				this.crmCall(val);
			}
		}
	}
</script>

<style></style>